#include <bits/stdc++.h>
#include <algorithm>
using namespace std;
int main() 
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);
	int t,n,m,konacno[5];
	unsigned long long a[75000],b[75000];
	cin>>t;
	for(int p=0;p<t;p++)
	{
		cin>>n>>m;
		for(int i=0;i<n;i++)
		{
			cin>>a[i];
		}
		for(int i=0;i<m;i++)
		{
			cin>>b[i];
		}
		sort(a,a+n);
		unsigned long long min=a[1]-a[0];
		for(int i=2;i<n;i++)
		{
			if(a[i]-a[i-1]<min)
			{
				min=a[i]-a[i-1];
			}
		}
		long long posto;
		posto=a[0]%min;
		int jn=1;
		while(a[jn]%min==posto&&jn!=n)
		{
			jn++;
		}
		if(jn<n)
		{
			konacno[p]=0;
		}
		else
		{
			int jm=0;
			while(b[jm]%min!=posto&&jm!=m)
			{
				jm++;
			}
			if(jm<m)
			{
				konacno[p]=0;
			}
			else
			{
				konacno[p]=1;
			}
		}
	}
	for(int i=0;i<t;i++)
	{
		cout<<konacno[i]<<"\n";
	}
	return 0;
}